Device = 16F873	 
Xtal = 4	 
'------------------------------------- -------------------------------------
Declare Adin_Res 10	                        ' P    = 10
Declare Adin_Tad FRC 	                    '    = FRC 
Declare Adin_Stime 50                       '     50    
'-------------------------------  --------------------------------
Declare LCD_Type ALPHA                      '   -  - 
Declare LCD_DTPin PORTB.4                   '    
Declare LCD_ENPin PORTB.3                   '   E
Declare LCD_RSPin PORTB.2                   '   RS 
Declare LCD_Interface 4                     '   
Declare LCD_CommandUs 2000                  '     
Declare LCD_DataUs 50                       '    
Declare LCD_Lines 2                         '    
'------------------------------------ ------------------------------------
'Declare PortB_Pullups = OFF                 '     PORTB 
Declare All_Digital = OFF                   '        
ADCON1 = %10000000                          '    PORTA   
TRISA = %00000011                           '   () AN0,AN1 (PORTA.0 ,PORTA.1) 
TRISC = %01011011                           '
TRISB = %00000000
PORTB = %00000010
PORTC = %00000000
'-------------------------- OPTION_REG ----------------------------------------
Symbol PS0 = OPTION_REG.0                   '    TMR0 
Symbol PS1 = OPTION_REG.1                   '    TMR0 
Symbol PS2 = OPTION_REG.2                   '    TMR0 
Symbol PSA = OPTION_REG.3                   '    
Symbol T0SE = OPTION_REG.4                  '    TMR0     
Symbol T0CS = OPTION_REG.5                  '     TMR0 
Symbol INTEDG = OPTION_REG.6                '         INT 
Symbol NOT_RBPU = OPTION_REG.7              '     PORTB 
                                                               
'-------------------------- INTCON --------------------------------------------
Symbol RBIF = INTCON.0                      '     PORTB.4-PORTB.7
Symbol INTF = INTCON.1                      '     PORTB.0(INT)                                                                   
Symbol T0IF = INTCON.2                      '   TMR0 
Symbol RBIE = INTCON.3                      '     PORTB.4-PORTB.7
Symbol INTE = INTCON.4                      '     PORTB.0(INT)
Symbol T0IE = INTCON.5                      '      TMR0
Symbol PEIE = INTCON.6                      '      
Symbol GIE  = INTCON.7                      '    

'--------------------------------- ----------------------------------
Dim VAR1    As Word                         ' VAR1  
Dim VAR2    As Word                         ' VAR2  
Dim Uc      As Float                        '   U
Dim Ic      As Float                        '   I
Dim U       As Float                        ' 
Dim I       As Float                        ' 
Dim Up      As Float                        '  
Dim Ip      As Float                        '  
Dim PWMout  As Word                         '   PWMout Word
Dim BIG     As Dword                        '    
Dim BIG1    As BIG.HighWord
Dim Hour    As Byte                         ' 
Dim Minute  As Byte                         ' 
Dim Sec     As Byte                         ' 
Dim SND     As Byte                         ' 

'Symbol SB3      = PORTC.0                  ' . 
Symbol SB4      = PORTC.1                   ' CTOP
Symbol SB1      = PORTC.3                   ' Charge
'Symbol SB2      = PORTC.4                  ' Save
Symbol PS_ON    = PORTC.5  	                '  
Symbol SP       = PORTC.7                   ' 
Symbol Zar      = PORTB.0  	                ' 
Symbol No_Zar   = PORTB.1  	                '  

'--------------------------  TMR0   --------------------
OPTION_REG = %10000111
TMR0 = $00                                  '   TMR0 
T0IE = 1 
GIE = 1                                     '   
BIG = 1000000
On_Interrupt GoTo Int_Label 
Uc = 50.6                                    '   U
Ic = 51.1                                    '   I 
Hour = 0        
Minute = 0 
Sec = 0
' ----------------------------------------------- init -----------------------------------------------
PWMout = 0	                                '	                                
Cls                                         '
DelayMS 200                                 ' 
Print At 1, 1, "AVTO ACCU CHARGE"           ' 
Print At 2, 1, "WWW.PICBASIC.RU "           ' 
DelayMS 2000                                '  2
Cls                                         ' 
Print At 1, 1, "CHARGE I=5A 36H "           '
Print At 2, 1, "SAVE  U=14.5 I=1"           '
DelayMS 2000                                '
Cls                                         '
Print At 1, 1, "Soft V2.0 290311"           '   
Print At 2, 4, "Andriy  S  "                '
DelayMS 2000                                '
Cls                                         '
Sec = 0                                     '
Minute = 0                                  '
Hour = 0                                    '
PWMout = 0                                  '
                                
'-------------------------------- ---------------------------------------
MainProgram:
VAR1 = ADIn 0 	                                  '    0-       VAR1
DelayUS 2
U = VAR1 / Uc                                     '  U  20
If SB1 = 0 And U < 13 Then                        ' !!    13    
    DelayMS 150 
    High SP
    DelayMS 150
    Low SP
    GoTo Charge
EndIf

If SB1 = 0 And U > 13 Then                        ' !!    13    
    DelayMS 100 
    High SP
    DelayMS 100
    Low SP
    GoTo Seve
EndIf

Print At 1, 1, "AVTOSELECT  MODE"
Print At 2, 1, "U battery :", Dec1 U, "V  ", 
If PWMout < 0 Then PWMout = 0                       ' !!!!!!!!!!!!!!!  - 
If PWMout > 255 Then PWMout = 255
HPWM 1, PWMout, 1000

Sec = 0
Minute = 0
Hour = 0
GoTo MainProgram                                    '    
End
'--------------------------  --------------------------
Int_Label: ' 
Context Save '   
If T0IF = 1 Then BIG1 = BIG1 -1 '  TMR0,        BIG1 ,   ,    65536  BIG ,    
If BIG < 0 Then BIG = BIG + 1000000 : Inc Sec ' BIG < 0     ,      1000000 
T0IF = 0 '   
Context Restore '    
End
'----------------------------  Charge--------------------------------
Charge:

VAR1 = ADIn 0 	                                 '    0-       VAR1
DelayUS 2

VAR2 = ADIn 1                                    '    1-       VAR2
DelayUS 2                                        '  2 

U = VAR1 / Uc                                    '  U  20
I = VAR2 / Ic                                    '  I  20 
Ip = 5
   
If U < 9 Then                                     '        
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    Sec = 0 
    Minute = 0
    Hour = 0
    For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND                                       '   9    
    GoTo MainProgram     
EndIf

If U > 9 Then                                      ' 
    DelayMS 100
    High PS_ON
    High Zar
    Low No_Zar                                               
EndIf

If U < 9.2 Then                                     '     9.2    
     For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
     Next SND
EndIf

If U > 15.5 And I > 0 Then Dec PWMout               ' = PWMout - 1   15.5    > 0

If U > 18 Then                                      '  18 
    DelayMS 1000 
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    Sec = 0 
    Minute = 0
    Hour = 0
     For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND        
EndIf

If I < Ip Then                                      '      
    Inc PWMout                                      ' = PWMout + 1 
ElseIf I > Ip Then                                  ' 
    Dec PWMout                                      ' = PWMout -1    9,5     
EndIf  

If I > 10 Then                                       '    10    = 0   
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    Sec = 0 
    Minute = 0
    Hour = 0
    For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND         
EndIf

If SB4 = 0 Then                                     '    - SB4   
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    Sec = 0 
    Minute = 0
    Hour = 0
    For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND
        Ip = 0
        Up = 0         
    GoTo MainProgram     
EndIf

If PWMout < 0 Then                                  ' !!!!!!!!!!!!!!!   
        PWMout = 0 
 ElseIf PWMout > 255 Then 
        PWMout = 255
EndIf

HPWM 1, PWMout, 1000

If Sec = 60 Then                                    '   60 ,    ,   
    Sec = 0 
    Inc Minute 
EndIf

If Minute = 60 Then                                 '   60 ,    0,   
    Minute = 0 
    Inc Hour 
EndIf

If Hour = 36 Then 
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    Sec = 0 
    Minute = 0
    Hour = 0
     For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND    
    GoTo Seve    
EndIf
                                   
Print At 1, 1, "CHARGE  "
Print At 1, 9, Dec2 Hour, ":", Dec2 Minute, ":", Dec2 Sec
Print At 2, 1, "U:" , Dec1 U , "V  "                '        VAR1
Print At 2, 10, "I:" , Dec1 I , "A  "               '        VAR2
GoTo Charge                                         '    
End  

'--------------------------  Save--------------------------
Seve:

VAR1 = ADIn 0                                    '    0-       VAR1
    DelayUS 2                                       '  2 

VAR2 = ADIn 1                                    '    1-       VAR2
    DelayUS 2                                       '  2 

U = VAR1 / Uc                                    '  U  20
I = VAR2 / Ic                                    '  I  20 

Up = 15.5
Ip = 1
    
If U < 13 Then                                       '   13     
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
     For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND                                         '  
    GoTo MainProgram                                 '  
EndIf
If U < 13.2 Then                                     '     13.2    
     For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND
EndIf
    
If U > 13 Then                                      ' 
     DelayMS 100
    High PS_ON
    High Zar
    Low No_Zar
EndIf


If U > 18 Then                                      '  18 
    DelayMS 500 
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
       For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND
EndIf

If U < Up Then 
    Inc PWMout                                      ' = PWMout + 1 
ElseIf Up > U Then 
    Dec PWMout                                      ' = PWMout -1 
EndIf 

If I > Ip Then Dec PWMout                           ' = PWMout -1  

If PWMout < 0 Then                                  ' !!!!!!!!!!!!!!!   
        PWMout = 0 
ElseIf PWMout > 255 Then 
        PWMout = 255
EndIf

HPWM 1, PWMout, 1000                              '

If I > 10 Then                                      '    10    = 0   
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    Sec = 0 
    Minute = 0
    Hour = 0
    For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND         
EndIf
If SB4 = 0 Then                                     '    - SB4   
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    For SND = 0 To 4
        High SP
        DelayMS 100 
        Low SP
        DelayMS 100 
    Next SND
        Ip = 0
        Up = 0 
    GoTo MainProgram
EndIf

Print At 1, 1, "SAVE        MODE"
Print At 2, 1, "U:" , Dec1 U, "V "                  '        VAR1
Print At 2, 9, "I:" , Dec1 I, "A  "                 '        VAR2
GoTo Seve                                           '    
End                                          









